'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

require('rxjs/add/observable/combineLatest');
require('rxjs/add/operator/distinct');
require('rxjs/add/operator/map');
require('rxjs/add/operator/publishReplay');
require('rxjs/add/operator/take');
require('rxjs/add/operator/toPromise');
var Koa = _interopDefault(require('koa'));
var Observable = require('rxjs/Observable');
var http = _interopDefault(require('http'));
var https = _interopDefault(require('https'));
var parser = _interopDefault(require('ua-parser-js'));
var convert = _interopDefault(require('koa-convert'));
var cors = _interopDefault(require('koa-cors'));
var mount = _interopDefault(require('koa-mount'));
var _ = _interopDefault(require('lodash'));
var neoBlockchainCore = require('neo-blockchain-core');
var compose = _interopDefault(require('koa-compose'));
var compress = _interopDefault(require('koa-compress'));
var connect = _interopDefault(require('koa-connect'));
var jayson = _interopDefault(require('jayson/promise'));
var body = _interopDefault(require('koa-better-body'));

function _typeof(obj) {
  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function _asyncToGenerator(fn) {
  return function () {
    var self = this,
        args = arguments;
    return new Promise(function (resolve, reject) {
      var gen = fn.apply(self, args);

      function step(key, arg) {
        try {
          var info = gen[key](arg);
          var value = info.value;
        } catch (error) {
          reject(error);
          return;
        }

        if (info.done) {
          resolve(value);
        } else {
          Promise.resolve(value).then(_next, _throw);
        }
      }

      function _next(value) {
        step("next", value);
      }

      function _throw(err) {
        step("throw", err);
      }

      _next();
    });
  };
}

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
  if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
}

function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  }

  if (!self) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _sliceIterator(arr, i) {
  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _slicedToArray(arr, i) {
  if (Array.isArray(arr)) {
    return arr;
  } else if (Symbol.iterator in Object(arr)) {
    return _sliceIterator(arr, i);
  } else {
    throw new TypeError("Invalid attempt to destructure non-iterable instance");
  }
}

var getUA = (function (ua) {
  var userAgent = {
    ua: ua,
    browser: {
      name: '',
      version: ''
    },
    device: {
      model: '',
      type: '',
      vendor: ''
    },
    engine: {
      name: '',
      version: ''
    },
    os: {
      name: '',
      version: ''
    },
    cpu: {
      architecture: ''
    }
  };
  var error = null;

  try {
    userAgent = parser(ua);
  } catch (err) {
    error = err;
  }

  if (error != null) {
    return {
      type: 'error',
      userAgent: userAgent,
      error: error
    };
  }

  return {
    type: 'valid',
    userAgent: userAgent,
    error: undefined
  };
});

// eslint-disable-next-line

var getLog = function getLog(ctx) {
  var log = ctx.state.log;

  if (log == null) {
    ctx.throw(500);
    throw new Error('For Flow');
  }

  return log;
};

var simpleMiddleware = function simpleMiddleware(name, middleware) {
  return {
    name: name,
    middleware: middleware
  };
};

var context = (function (_ref) {
  var createLog = _ref.createLog,
      createProfile = _ref.createProfile;
  return simpleMiddleware('context', function () {
    var _ref2 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee(ctx, next) {
      var _getUA, userAgent, type, error, log;

      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _getUA = getUA(ctx.request.headers['user-agent']), userAgent = _getUA.userAgent, type = _getUA.type, error = _getUA.error;
              ctx.state.userAgent = userAgent;
              log = createLog(ctx);
              ctx.state.log = log;
              ctx.state.profile = createProfile(log);

              if (type === 'error') {
                log({
                  event: 'USER_AGENT_PARSE_ERROR',
                  error: error
                });
              }

              _context.next = 8;
              return next();

            case 8:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    return function (_x, _x2) {
      return _ref2.apply(this, arguments);
    };
  }());
});

var cors$1 = simpleMiddleware('cors', convert(cors({
  origin: true
})));

var liveHealthCheck = simpleMiddleware('liveHealthCheck', mount('/live_health_check', function () {
  var _ref = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee(ctx) {
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            ctx.status = 200;

          case 1:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function (_x) {
    return _ref.apply(this, arguments);
  };
}()));

var nowSeconds = function nowSeconds() {
  return Date.now() / 1000;
};

var getLatencySeconds = function getLatencySeconds(startTimeSeconds) {
  var latencySeconds = nowSeconds() - startTimeSeconds;
  return Math.round(latencySeconds * 1000) / 1000;
};

var logger = simpleMiddleware('logger', function () {
  var _ref = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee(ctx, next) {
    var startTimeSeconds, log;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            startTimeSeconds = nowSeconds();
            log = getLog(ctx);
            _context.prev = 2;
            _context.next = 5;
            return next();

          case 5:
            _context.next = 11;
            break;

          case 7:
            _context.prev = 7;
            _context.t0 = _context["catch"](2);

            if (_context.t0.code !== 'ECONNABORTED') {
              log({
                event: 'REQUEST_ERROR',
                error: _context.t0,
                httpRequest: {
                  latency: getLatencySeconds(startTimeSeconds)
                }
              });
            }

            throw _context.t0;

          case 11:
            _context.prev = 11;
            log({
              event: 'REQUEST',
              httpRequest: {
                latency: getLatencySeconds(startTimeSeconds)
              }
            });
            return _context.finish(11);

          case 14:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this, [[2, 7, 11, 14]]);
  }));

  return function (_x, _x2) {
    return _ref.apply(this, arguments);
  };
}());
var onError = function onError(_ref2) {
  var logIn = _ref2.log;
  return function (error, ctx) {
    var log = logIn;

    if (ctx != null) {
      try {
        log = getLog(ctx); // eslint-disable-next-line
      } catch (error) {// eslint-disable-next-line
      }
    }

    log({
      event: 'UNEXPECTED_REQUEST_ERROR',
      error: error
    });
  };
};

var TIMEOUT_MS = 5000;

var fetchCount = function () {
  var _ref = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee(endpoint) {
    var response, result, responseJSON;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.prev = 0;
            _context.next = 3;
            return fetch(endpoint, {
              method: 'POST',
              headers: {
                'Content-Type': 'application/json'
              },
              body: JSON.stringify([{
                jsonrpc: '2.0',
                method: 'getblockcount',
                params: [],
                id: 4
              }]),
              timeout: TIMEOUT_MS
            });

          case 3:
            response = _context.sent;

            if (response.ok) {
              _context.next = 6;
              break;
            }

            return _context.abrupt("return", null);

          case 6:
            _context.next = 8;
            return response.json();

          case 8:
            result = _context.sent;

            if (!Array.isArray(result)) {
              _context.next = 14;
              break;
            }

            responseJSON = result[0];

            if (!(responseJSON.error || responseJSON.result == null)) {
              _context.next = 13;
              break;
            }

            return _context.abrupt("return", null);

          case 13:
            return _context.abrupt("return", responseJSON.result);

          case 14:
            return _context.abrupt("return", null);

          case 17:
            _context.prev = 17;
            _context.t0 = _context["catch"](0);
            return _context.abrupt("return", null);

          case 20:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this, [[0, 17]]);
  }));

  return function fetchCount(_x) {
    return _ref.apply(this, arguments);
  };
}();

var fetchTallestBlockIndex = function () {
  var _ref2 = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee2(rpcEndpoints) {
    var counts;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return Promise.all(rpcEndpoints.map(function (rpcEndpoint) {
              return fetchCount(rpcEndpoint);
            }));

          case 2:
            counts = _context2.sent;
            return _context2.abrupt("return", _.max(counts.filter(Boolean).map(function (count) {
              return count - 1;
            })));

          case 4:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function fetchTallestBlockIndex(_x2) {
    return _ref2.apply(this, arguments);
  };
}();

var readyHealthCheck = (function (_ref3) {
  var blockchain = _ref3.blockchain,
      options = _ref3.options;
  return simpleMiddleware('readyHealthCheck', mount('/ready_health_check', function () {
    var _ref4 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee3(ctx) {
      var log, index;
      return regeneratorRuntime.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              log = getLog(ctx);
              _context3.next = 3;
              return fetchTallestBlockIndex(options.rpcEndpoints);

            case 3:
              index = _context3.sent;

              if (index == null || blockchain.currentBlockIndex >= index - options.offset) {
                ctx.status = 200;
              } else {
                log({
                  event: 'READY_HEALTH_CHECK_ERROR',
                  index: index,
                  currentBlockIndex: blockchain.currentBlockIndex
                });
                ctx.status = 500;
              }

            case 5:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3, this);
    }));

    return function (_x3) {
      return _ref4.apply(this, arguments);
    };
  }()));
});

var _fixBabelExtend = function (O) {
  var gOPD = O.getOwnPropertyDescriptor,
      gPO = O.getPrototypeOf || function (o) {
    return o.__proto__;
  },
      sPO = O.setPrototypeOf || function (o, p) {
    o.__proto__ = p;
    return o;
  },
      construct = _typeof(Reflect) === 'object' ? Reflect.construct : function (Parent, args, Class) {
    var Constructor,
        a = [null];
    a.push.apply(a, args);
    Constructor = Parent.bind.apply(Parent, a);
    return sPO(new Constructor(), Class.prototype);
  };

  return function fixBabelExtend(Class) {
    var Parent = gPO(Class);
    return sPO(Class, sPO(function Super() {
      return construct(Parent, arguments, gPO(this).constructor);
    }, Parent));
  };
}(Object);

var RPCError = _fixBabelExtend(
/*#__PURE__*/
function (_Error) {
  _inherits(RPCError, _Error);

  function RPCError(code, message, data) {
    var _this;

    _classCallCheck(this, RPCError);
    _this = _possibleConstructorReturn(this, (RPCError.__proto__ || Object.getPrototypeOf(RPCError)).call(this, message));
    _this.code = code;
    _this.data = data;
    return _this;
  }

  return RPCError;
}(Error));
var RPCUnknownError = _fixBabelExtend(
/*#__PURE__*/
function (_Error2) {
  _inherits(RPCUnknownError, _Error2);

  function RPCUnknownError(error) {
    var _this2;

    _classCallCheck(this, RPCUnknownError);
    _this2 = _possibleConstructorReturn(this, (RPCUnknownError.__proto__ || Object.getPrototypeOf(RPCUnknownError)).call(this, 'Unknown RPC Error'));
    _this2.error = error;
    return _this2;
  }

  return RPCUnknownError;
}(Error));

var bodyParser = (function () {
  return convert(body());
});

var rpc = (function (_ref) {
  var blockchain = _ref.blockchain,
      node = _ref.node;

  var checkHeight = function checkHeight(height) {
    if (height < 0 && height > blockchain.currentBlockIndex) {
      // eslint-disable-next-line
      throw server.error(-100, 'Invalid Height');
    }
  };

  var server;
  var handlers = {
    getaccountstate: function () {
      var _ref2 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee(args) {
        var hash, account;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                hash = neoBlockchainCore.crypto.addressToScriptHash({
                  addressVersion: blockchain.settings.addressVersion,
                  address: args[0]
                });
                _context.next = 3;
                return blockchain.account.tryGet({
                  hash: hash
                });

              case 3:
                account = _context.sent;

                if (account == null) {
                  account = new neoBlockchainCore.Account({
                    hash: hash
                  });
                }

                return _context.abrupt("return", account.serializeJSON(blockchain.serializeJSONContext));

              case 6:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function getaccountstate(_x) {
        return _ref2.apply(this, arguments);
      }

      return getaccountstate;
    }(),
    getassetstate: function () {
      var _ref3 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee2(args) {
        var asset;
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return blockchain.asset.tryGet({
                  hash: neoBlockchainCore.JSONHelper.readUInt256(args[0])
                });

              case 2:
                asset = _context2.sent;

                if (!(asset == null)) {
                  _context2.next = 5;
                  break;
                }

                throw server.error(-100, 'Unknown asset');

              case 5:
                return _context2.abrupt("return", asset.serializeJSON(blockchain.serializeJSONContext));

              case 6:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function getassetstate(_x2) {
        return _ref3.apply(this, arguments);
      }

      return getassetstate;
    }(),
    getbestblockhash: function () {
      var _ref4 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee3() {
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                return _context3.abrupt("return", neoBlockchainCore.JSONHelper.writeUInt256(blockchain.currentBlock.hash));

              case 1:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function getbestblockhash() {
        return _ref4.apply(this, arguments);
      }

      return getbestblockhash;
    }(),
    getblock: function () {
      var _ref5 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee4(args) {
        var hashOrIndex, block, json;
        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                hashOrIndex = args[0];

                if (typeof args[0] === 'string') {
                  hashOrIndex = neoBlockchainCore.JSONHelper.readUInt256(args[0]);
                }

                _context4.next = 4;
                return blockchain.block.tryGet({
                  hashOrIndex: hashOrIndex
                });

              case 4:
                block = _context4.sent;

                if (!(block == null)) {
                  _context4.next = 7;
                  break;
                }

                throw server.error(-100, 'Unknown block');

              case 7:
                if (!args[1]) {
                  _context4.next = 12;
                  break;
                }

                _context4.next = 10;
                return block.serializeJSON(blockchain.serializeJSONContext);

              case 10:
                json = _context4.sent;
                return _context4.abrupt("return", json);

              case 12:
                return _context4.abrupt("return", block.serializeWire().toString('hex'));

              case 13:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function getblock(_x3) {
        return _ref5.apply(this, arguments);
      }

      return getblock;
    }(),
    getblockcount: function () {
      var _ref6 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee5() {
        return regeneratorRuntime.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                return _context5.abrupt("return", blockchain.currentBlockIndex + 1);

              case 1:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function getblockcount() {
        return _ref6.apply(this, arguments);
      }

      return getblockcount;
    }(),
    getblockhash: function () {
      var _ref7 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee6(args) {
        var height, block;
        return regeneratorRuntime.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                height = args[0];
                checkHeight(height);
                _context6.next = 4;
                return blockchain.block.get({
                  hashOrIndex: height
                });

              case 4:
                block = _context6.sent;
                return _context6.abrupt("return", neoBlockchainCore.JSONHelper.writeUInt256(block.hash));

              case 6:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function getblockhash(_x4) {
        return _ref7.apply(this, arguments);
      }

      return getblockhash;
    }(),
    getblocksysfee: function () {
      var _ref8 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee7(args) {
        var height, header, blockSystemFee;
        return regeneratorRuntime.wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                height = args[0];
                checkHeight(height);
                _context7.next = 4;
                return blockchain.header.get({
                  hashOrIndex: height
                });

              case 4:
                header = _context7.sent;
                _context7.next = 7;
                return blockchain.blockSystemFee.get({
                  hash: header.hash
                });

              case 7:
                blockSystemFee = _context7.sent;
                return _context7.abrupt("return", blockSystemFee.systemFee.toString(10));

              case 9:
              case "end":
                return _context7.stop();
            }
          }
        }, _callee7, this);
      }));

      function getblocksysfee(_x5) {
        return _ref8.apply(this, arguments);
      }

      return getblocksysfee;
    }(),
    getconnectioncount: function () {
      var _ref9 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee8() {
        return regeneratorRuntime.wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                return _context8.abrupt("return", node.connectedPeersCount);

              case 1:
              case "end":
                return _context8.stop();
            }
          }
        }, _callee8, this);
      }));

      function getconnectioncount() {
        return _ref9.apply(this, arguments);
      }

      return getconnectioncount;
    }(),
    getcontractstate: function () {
      var _ref10 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee9(args) {
        var hash, contract;
        return regeneratorRuntime.wrap(function _callee9$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                hash = neoBlockchainCore.JSONHelper.readUInt160(args[0]);
                _context9.next = 3;
                return blockchain.contract.tryGet({
                  hash: hash
                });

              case 3:
                contract = _context9.sent;

                if (!(contract == null)) {
                  _context9.next = 6;
                  break;
                }

                throw server.error(-100, 'Unknown contract');

              case 6:
                return _context9.abrupt("return", contract.serializeJSON(blockchain.serializeJSONContext));

              case 7:
              case "end":
                return _context9.stop();
            }
          }
        }, _callee9, this);
      }));

      function getcontractstate(_x6) {
        return _ref10.apply(this, arguments);
      }

      return getcontractstate;
    }(),
    getrawmempool: function () {
      var _ref11 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee10() {
        return regeneratorRuntime.wrap(function _callee10$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                return _context10.abrupt("return", neoBlockchainCore.utils.values(node.memPool).map(function (transaction) {
                  return neoBlockchainCore.JSONHelper.writeUInt256(transaction.hash);
                }));

              case 1:
              case "end":
                return _context10.stop();
            }
          }
        }, _callee10, this);
      }));

      function getrawmempool() {
        return _ref11.apply(this, arguments);
      }

      return getrawmempool;
    }(),
    getrawtransaction: function () {
      var _ref12 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee11(args) {
        var hash, transaction, json;
        return regeneratorRuntime.wrap(function _callee11$(_context11) {
          while (1) {
            switch (_context11.prev = _context11.next) {
              case 0:
                hash = neoBlockchainCore.JSONHelper.readUInt256(args[0]);
                transaction = node.memPool[neoBlockchainCore.common.uInt256ToHex(hash)];

                if (!(transaction == null)) {
                  _context11.next = 6;
                  break;
                }

                _context11.next = 5;
                return blockchain.transaction.tryGet({
                  hash: hash
                });

              case 5:
                transaction = _context11.sent;

              case 6:
                if (!(transaction == null)) {
                  _context11.next = 8;
                  break;
                }

                throw server.error(-100, 'Unknown transaction');

              case 8:
                if (!args[1]) {
                  _context11.next = 13;
                  break;
                }

                _context11.next = 11;
                return transaction.serializeJSON(blockchain.serializeJSONContext);

              case 11:
                json = _context11.sent;
                return _context11.abrupt("return", json);

              case 13:
                return _context11.abrupt("return", transaction.serializeWire().toString('hex'));

              case 14:
              case "end":
                return _context11.stop();
            }
          }
        }, _callee11, this);
      }));

      function getrawtransaction(_x7) {
        return _ref12.apply(this, arguments);
      }

      return getrawtransaction;
    }(),
    getstorage: function () {
      var _ref13 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee12(args) {
        var hash, key, item;
        return regeneratorRuntime.wrap(function _callee12$(_context12) {
          while (1) {
            switch (_context12.prev = _context12.next) {
              case 0:
                hash = neoBlockchainCore.JSONHelper.readUInt160(args[0]);
                key = Buffer.from(args[1], 'hex');
                _context12.next = 4;
                return blockchain.storageItem.tryGet({
                  hash: hash,
                  key: key
                });

              case 4:
                item = _context12.sent;
                return _context12.abrupt("return", item == null ? null : item.value.toString('hex'));

              case 6:
              case "end":
                return _context12.stop();
            }
          }
        }, _callee12, this);
      }));

      function getstorage(_x8) {
        return _ref13.apply(this, arguments);
      }

      return getstorage;
    }(),
    gettxout: function () {
      var _ref14 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee13(args) {
        var hash, index, output;
        return regeneratorRuntime.wrap(function _callee13$(_context13) {
          while (1) {
            switch (_context13.prev = _context13.next) {
              case 0:
                hash = neoBlockchainCore.JSONHelper.readUInt256(args[0]);
                index = args[1];
                _context13.next = 4;
                return blockchain.output.get({
                  hash: hash,
                  index: index
                });

              case 4:
                output = _context13.sent;
                return _context13.abrupt("return", output == null ? null : output.serializeJSON(blockchain.serializeJSONContext, index));

              case 6:
              case "end":
                return _context13.stop();
            }
          }
        }, _callee13, this);
      }));

      function gettxout(_x9) {
        return _ref14.apply(this, arguments);
      }

      return gettxout;
    }(),
    invoke: function () {
      var _ref15 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee14() {
        return regeneratorRuntime.wrap(function _callee14$(_context14) {
          while (1) {
            switch (_context14.prev = _context14.next) {
              case 0:
                throw server.error(-101, 'Not implemented');

              case 1:
              case "end":
                return _context14.stop();
            }
          }
        }, _callee14, this);
      }));

      function invoke() {
        return _ref15.apply(this, arguments);
      }

      return invoke;
    }(),
    invokefunction: function () {
      var _ref16 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee15() {
        return regeneratorRuntime.wrap(function _callee15$(_context15) {
          while (1) {
            switch (_context15.prev = _context15.next) {
              case 0:
                throw server.error(-101, 'Not implemented');

              case 1:
              case "end":
                return _context15.stop();
            }
          }
        }, _callee15, this);
      }));

      function invokefunction() {
        return _ref16.apply(this, arguments);
      }

      return invokefunction;
    }(),
    invokescript: function () {
      var _ref17 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee16() {
        return regeneratorRuntime.wrap(function _callee16$(_context16) {
          while (1) {
            switch (_context16.prev = _context16.next) {
              case 0:
                throw server.error(-101, 'Not implemented');

              case 1:
              case "end":
                return _context16.stop();
            }
          }
        }, _callee16, this);
      }));

      function invokescript() {
        return _ref17.apply(this, arguments);
      }

      return invokescript;
    }(),
    invokescriptv2: function () {
      var _ref18 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee17(args) {
        var script, result;
        return regeneratorRuntime.wrap(function _callee17$(_context17) {
          while (1) {
            switch (_context17.prev = _context17.next) {
              case 0:
                script = neoBlockchainCore.JSONHelper.readBuffer(args[0]);
                _context17.next = 3;
                return blockchain.invokeScript(script);

              case 3:
                result = _context17.sent;
                return _context17.abrupt("return", result.serializeJSON(blockchain.serializeJSONContext));

              case 5:
              case "end":
                return _context17.stop();
            }
          }
        }, _callee17, this);
      }));

      function invokescriptv2(_x10) {
        return _ref18.apply(this, arguments);
      }

      return invokescriptv2;
    }(),
    sendrawtransaction: function () {
      var _ref19 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee18(args) {
        var transaction;
        return regeneratorRuntime.wrap(function _callee18$(_context18) {
          while (1) {
            switch (_context18.prev = _context18.next) {
              case 0:
                transaction = neoBlockchainCore.deserializeTransactionWire({
                  context: blockchain.deserializeWireContext,
                  buffer: neoBlockchainCore.JSONHelper.readBuffer(args[0])
                });
                _context18.prev = 1;
                _context18.next = 4;
                return node.relayTransaction(transaction);

              case 4:
                return _context18.abrupt("return", true);

              case 7:
                _context18.prev = 7;
                _context18.t0 = _context18["catch"](1);
                return _context18.abrupt("return", false);

              case 10:
              case "end":
                return _context18.stop();
            }
          }
        }, _callee18, this, [[1, 7]]);
      }));

      function sendrawtransaction(_x11) {
        return _ref19.apply(this, arguments);
      }

      return sendrawtransaction;
    }(),
    submitblock: function () {
      var _ref20 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee19() {
        return regeneratorRuntime.wrap(function _callee19$(_context19) {
          while (1) {
            switch (_context19.prev = _context19.next) {
              case 0:
                throw server.error(-101, 'Not implemented');

              case 1:
              case "end":
                return _context19.stop();
            }
          }
        }, _callee19, this);
      }));

      function submitblock() {
        return _ref20.apply(this, arguments);
      }

      return submitblock;
    }(),
    validateaddress: function () {
      var _ref21 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee20(args) {
        var scriptHash;
        return regeneratorRuntime.wrap(function _callee20$(_context20) {
          while (1) {
            switch (_context20.prev = _context20.next) {
              case 0:
                try {
                  scriptHash = neoBlockchainCore.crypto.addressToScriptHash({
                    addressVersion: blockchain.settings.addressVersion,
                    address: args[0]
                  });
                } catch (error) {// eslint-disable-next-line
                }

                return _context20.abrupt("return", {
                  address: args[0],
                  isvalid: scriptHash != null
                });

              case 2:
              case "end":
                return _context20.stop();
            }
          }
        }, _callee20, this);
      }));

      function validateaddress(_x12) {
        return _ref21.apply(this, arguments);
      }

      return validateaddress;
    }(),
    getpeers: function () {
      var _ref22 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee21() {
        return regeneratorRuntime.wrap(function _callee21$(_context21) {
          while (1) {
            switch (_context21.prev = _context21.next) {
              case 0:
                throw server.error(-101, 'Not implemented');

              case 1:
              case "end":
                return _context21.stop();
            }
          }
        }, _callee21, this);
      }));

      function getpeers() {
        return _ref22.apply(this, arguments);
      }

      return getpeers;
    }(),
    getactions: function () {
      var _ref23 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee22(args) {
        var actionsObservable, _scriptHash, actions;

        return regeneratorRuntime.wrap(function _callee22$(_context22) {
          while (1) {
            switch (_context22.prev = _context22.next) {
              case 0:
                actionsObservable = blockchain.action.getAll({
                  blockIndexStart: args[0].blockIndexStart,
                  transactionIndexStart: args[0].transactionIndexStart,
                  indexStart: args[0].indexStart,
                  blockIndexStop: args[0].blockIndexStop,
                  transactionIndexStop: args[0].transactionIndexStop,
                  indexStop: args[0].indexStop
                });

                if (args[0].scriptHash != null) {
                  _scriptHash = neoBlockchainCore.JSONHelper.readUInt160(args[0].scriptHash);
                  actionsObservable = actionsObservable.filter(function (action) {
                    return neoBlockchainCore.common.uInt160Equal(action.scriptHash, _scriptHash);
                  });
                }

                _context22.next = 4;
                return actionsObservable.toArray().toPromise();

              case 4:
                actions = _context22.sent;
                return _context22.abrupt("return", actions.map(function (action) {
                  return action.serializeJSON(blockchain.serializeJSONContext);
                }));

              case 6:
              case "end":
                return _context22.stop();
            }
          }
        }, _callee22, this);
      }));

      function getactions(_x13) {
        return _ref23.apply(this, arguments);
      }

      return getactions;
    }(),
    getallstorage: function () {
      var _ref24 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee23(args) {
        var hash, items;
        return regeneratorRuntime.wrap(function _callee23$(_context23) {
          while (1) {
            switch (_context23.prev = _context23.next) {
              case 0:
                hash = neoBlockchainCore.JSONHelper.readUInt160(args[0]);
                _context23.next = 3;
                return blockchain.storageItem.getAll({
                  hash: hash
                }).toArray().toPromise();

              case 3:
                items = _context23.sent;
                return _context23.abrupt("return", items.map(function (item) {
                  return item.serializeJSON(blockchain.serializeJSONContext);
                }));

              case 5:
              case "end":
                return _context23.stop();
            }
          }
        }, _callee23, this);
      }));

      function getallstorage(_x14) {
        return _ref24.apply(this, arguments);
      }

      return getallstorage;
    }()
  };
  server = jayson.server(_.mapValues(handlers, function (handler) {
    return _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee24() {
      var result,
          logError,
          _args24 = arguments;
      return regeneratorRuntime.wrap(function _callee24$(_context24) {
        while (1) {
          switch (_context24.prev = _context24.next) {
            case 0:
              _context24.prev = 0;
              _context24.next = 3;
              return handler.apply(void 0, _args24);

            case 3:
              result = _context24.sent;
              return _context24.abrupt("return", result);

            case 7:
              _context24.prev = 7;
              _context24.t0 = _context24["catch"](0);
              logError = _context24.t0;

              if (!(_context24.t0 instanceof Error)) {
                if (_typeof(_context24.t0) === 'object' && _context24.t0.code != null && _context24.t0.message != null) {
                  logError = new RPCError(_context24.t0.code, _context24.t0.message, _context24.t0.data);
                } else {
                  logError = new RPCUnknownError(_context24.t0);
                }

                Error.captureStackTrace(logError);
              }

              blockchain.log({
                event: 'RPC_ERROR',
                error: logError
              });
              throw _context24.t0;

            case 13:
            case "end":
              return _context24.stop();
          }
        }
      }, _callee24, this, [[0, 7]]);
    }));
  }));
  return simpleMiddleware('rpc', mount('/rpc', compose([compress(), bodyParser(), function () {
    var _ref26 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee25(ctx, next) {
      var fields;
      return regeneratorRuntime.wrap(function _callee25$(_context25) {
        while (1) {
          switch (_context25.prev = _context25.next) {
            case 0:
              fields = ctx.request.fields;

              if (fields != null) {
                // $FlowFixMe
                ctx.req.body = fields;
              }

              _context25.next = 4;
              return next();

            case 4:
            case "end":
              return _context25.stop();
          }
        }
      }, _callee25, this);
    }));

    return function (_x15, _x16) {
      return _ref26.apply(this, arguments);
    };
  }(), connect(server.middleware({
    end: false
  }))])));
});

var RPCServer =
/*#__PURE__*/
function () {
  function RPCServer(_ref) {
    var log = _ref.log,
        createLogForContext = _ref.createLogForContext,
        createProfile = _ref.createProfile,
        blockchain$ = _ref.blockchain$,
        node$ = _ref.node$,
        environment = _ref.environment,
        options$ = _ref.options$,
        onError$$1 = _ref.onError;
    _classCallCheck(this, RPCServer);
    this._log = log;
    this._createLogForContext = createLogForContext;
    this._createProfile = createProfile;
    this._blockchain$ = blockchain$;
    this._node$ = node$;
    this._environment = environment;
    this._options$ = options$;
    this._shutdownFuncs = [];

    this._onError = onError$$1 || function () {};
  }

  _createClass(RPCServer, [{
    key: "start",
    value: function () {
      var _ref2 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee() {
        var app$;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                this._log({
                  event: 'SERVER_START'
                });

                app$ = this._getApp$();
                _context.next = 4;
                return Promise.all([this._startHTTPServer(app$), this._startHTTPSServer(app$)]);

              case 4:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function start() {
        return _ref2.apply(this, arguments);
      }

      return start;
    }()
  }, {
    key: "stop",
    value: function () {
      var _ref3 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee2() {
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return Promise.all(this._shutdownFuncs.map(function (func) {
                  return func();
                }));

              case 2:
                this._shutdownFuncs = [];

              case 3:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function stop() {
        return _ref3.apply(this, arguments);
      }

      return stop;
    }()
  }, {
    key: "_startHTTPServer",
    value: function () {
      var _ref4 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee3(app$) {
        var httpOptions, host, port, httpServer;
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                httpOptions = this._environment.http;

                if (!(httpOptions == null)) {
                  _context3.next = 3;
                  break;
                }

                return _context3.abrupt("return");

              case 3:
                host = httpOptions.host, port = httpOptions.port;
                httpServer = http.createServer();
                _context3.next = 7;
                return this._setupServer(httpServer, host, port, app$);

              case 7:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function _startHTTPServer(_x) {
        return _ref4.apply(this, arguments);
      }

      return _startHTTPServer;
    }()
  }, {
    key: "_startHTTPSServer",
    value: function () {
      var _ref5 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee4(app$) {
        var httpsOptions, key, cert, host, port, httpsServer;
        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                httpsOptions = this._environment.https;

                if (!(httpsOptions == null)) {
                  _context4.next = 3;
                  break;
                }

                return _context4.abrupt("return");

              case 3:
                key = httpsOptions.key, cert = httpsOptions.cert, host = httpsOptions.host, port = httpsOptions.port;
                httpsServer = https.createServer({
                  key: key,
                  cert: cert
                });
                _context4.next = 7;
                return this._setupServer(httpsServer, host, port, app$);

              case 7:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function _startHTTPSServer(_x2) {
        return _ref5.apply(this, arguments);
      }

      return _startHTTPSServer;
    }()
  }, {
    key: "_getApp$",
    value: function _getApp$() {
      var _this = this;

      return Observable.Observable.combineLatest(this._blockchain$, this._node$, this._options$.map(function (options) {
        return options.readyHealthCheck;
      }).distinct()).map(function (_ref6) {
        var _ref7 = _slicedToArray(_ref6, 3),
            blockchain = _ref7[0],
            node = _ref7[1],
            readyHealthCheckOptions = _ref7[2];

        var app = new Koa();
        app.proxy = true; // $FlowFixMe

        app.silent = true;
        app.on('error', onError({
          log: _this._log
        }));
        var middlewares = [context({
          createLog: _this._createLogForContext,
          createProfile: _this._createProfile
        }), liveHealthCheck, readyHealthCheck({
          blockchain: blockchain,
          options: readyHealthCheckOptions
        }), logger, cors$1, rpc({
          blockchain: blockchain,
          node: node
        })];

        for (var _i = 0; _i < middlewares.length; _i++) {
          var middleware = middlewares[_i];
          app.use(middleware.middleware);
        }

        return app;
      }).publishReplay(1).refCount();
    }
  }, {
    key: "_setupServer",
    value: function () {
      var _ref8 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee5(server, host, port, app$) {
        var _this2 = this;

        var onError$$1, listener, subscription, keepAliveSubscription;
        return regeneratorRuntime.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                onError$$1 = function onError$$1(event) {
                  return function (error) {
                    _this2._log({
                      event: event,
                      error: error
                    });

                    _this2.stop().then(function () {
                      return _this2._onError();
                    });
                  };
                };

                subscription = app$.subscribe({
                  next: function next(app) {
                    if (listener != null) {
                      server.removeListener('request', listener);
                    }

                    listener = app.callback();
                    server.on('request', listener);
                  },
                  error: onError$$1('SERVER_APP_SUBSCRIBE_ERROR')
                });

                this._shutdownFuncs.push(function () {
                  return subscription.unsubscribe();
                });

                keepAliveSubscription = this._options$.map(function (options) {
                  return options.server.keepAliveTimeout;
                }).distinct().subscribe({
                  next: function next(keepAliveTimeout) {
                    // $FlowFixMe
                    server.keepAliveTimeout = keepAliveTimeout; // eslint-disable-line
                  },
                  error: onError$$1('SERVER_KEEP_ALIVE_SUBSCRIBE_ERROR')
                });

                this._shutdownFuncs.push(function () {
                  return keepAliveSubscription.unsubscribe();
                });

                _context5.next = 7;
                return new Promise(function (resolve) {
                  return server.listen(port, host, 511, function () {
                    return resolve();
                  });
                });

              case 7:
                this._log({
                  event: 'SERVER_LISTENING',
                  host: host,
                  port: port
                });

                this._shutdownFuncs.push(function () {
                  return new Promise(function (resolve) {
                    return server.close(function () {
                      return resolve();
                    });
                  });
                });

              case 9:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function _setupServer(_x3, _x4, _x5, _x6) {
        return _ref8.apply(this, arguments);
      }

      return _setupServer;
    }()
  }]);
  return RPCServer;
}();

exports.RPCServer = RPCServer;
//# sourceMappingURL=index.js.map
